#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <signal.h>

void
signal_handler(int signo)
{

}

int
main()
{
	struct sigaction act;
	char buf[256];
	char *c;
	int len;

	memset(&act, 0, sizeof(act));
	act.sa_handler = signal_handler;
	act.sa_flags = 0;
	sigemptyset(&act.sa_mask);
	sigaction(SIGUSR1, &act, NULL);

	c = fgets(buf, sizeof(buf), stdin);

	if (c == NULL) {
		if (errno > 0)
			printf("error!: %s\n", strerror(errno));
		else
			printf("error!\n");
		exit(1);
	}

	len = strlen(c);

	if (len <= 0) {
		printf("empty input string\n");
		exit(1);
	}
	
	if (buf[len-1] != '\n') {
		printf("input too long\n");
		exit(1);
	}

	buf[--len] = '\0';

	printf("%s\n", buf);

	return 0;
}

